//+------------------------------------------------------------------+
//|                                                       extrem.mq4 |
//|                                                                  |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

extern double MaximumRisk = 0.09;
extern double DecreaseFactor = 3;
extern double Lots        = 1;
extern double SL          = 97;
extern double TP          = 20;
extern double Filtr       = 7;
extern double Long        = 3;
       

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
 
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
/*double LotsOptimized()
  {
   double lot=1;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/500,1);
   if(lot<1) lot=1;
   if(lot>10000) lot=10000;
   lot=Lots;
   return(lot);
  }  */
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/500,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
//   lot=Lots;
   return(lot);
  }  
  



//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   double H0, H1, L0, L1;
   int ticket, total, cnt;
   bool est_s, est_b;
   
   total=OrdersTotal();
   est_s=true;
   est_b=true;
/*
   for(cnt=0;cnt<total;cnt++)
      {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       if((OrderType()==OP_SELL) && (OrderSymbol()==Symbol())) est_s=false;
       if((OrderType()==OP_BUY) && (OrderSymbol()==Symbol())) est_b=false;
      }
*/
   if (total>0) {return(0);}
   H0=High[Highest(NULL,0,MODE_HIGH,Long,1)];
   L0=Low[Lowest(NULL,0,MODE_LOW,Long,1)];
   H1=H0+Filtr*Point;
   L1=L0-Filtr*Point;
   Print(H0, "  ", L0);

   if((Ask>=H1) && est_b)
     {
      ticket=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,Ask-SL*Point,Bid+TP*Point,"extrem",16384,0,Green);
     }
   if((Bid<=L1) && est_s)
     {
      ticket=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,Bid+SL*Point,Ask-TP*Point,"extrem",16384,0,Red); 
     }
     
   return(0);
  }

